import os

from PyQt4 import uic
from PyQt4.QtCore import Qt

from qgis.core import NULL

from mydialog import MyDialog


pluginPath = os.path.dirname(__file__)
WIDGET, BASE = uic.loadUiType(os.path.join(pluginPath, 'mywidgetbase.ui'))


class MyWidget(BASE, WIDGET):
    def __init__(self, parent=None):
        super(MyWidget, self).__init__(parent)
        self.setupUi(self)

        self.setFocusPolicy(Qt.StrongFocus)

        self.btnEdit.clicked.connect(self.edit)

    def value(self):
        text = self.lineEdit.text()
        if text == 'NULL':
            return NULL
        else:
            return text

    def setValue(self, value):
        if value:
            self.lineEdit.setText(text)
        else:
            self.lineEdit.setText('NULL')

    def edit(self):
        dlg = MyDialog()
        if dlg.exec_():
            if dlg.new is not None:
                self.lineEdit.setText(dlg.new)
