from PyQt4.QtGui import QHBoxLayout, QLabel

from qgis.gui import QgsEditorWidgetWrapper, QgsEditorConfigWidget, QgsEditorWidgetFactory

from mywidget import MyWidget


class MyWidgetWrapper(QgsEditorWidgetWrapper):
    def __init__(self, vl, fieldIdx, editor, parent):
        super(MyWidgetWrapper, self).__init__(vl, fieldIdx, editor, parent)

        self.widget = None

    def createWidget(self, parent):
        self.widget = MyWidget(parent)
        return self.widget

    def value(self):
        return self.widget.value()

    def setValue(self, value):
        self.widget.setValue(value)

    def initWidget(self, editor):
        self.widget = editor

    def valid(self):
        return True


class MyWidgetWrapperConfig(QgsEditorConfigWidget):
    def __init__(self, layer, fieldIndex, parent):
        QgsEditorConfigWidget.__init__(self, layer, fieldIndex, parent)
        self.setLayout(QHBoxLayout())
        label = QLabel('This is a test editor widget.')
        self.layout().addWidget(label)

    def config(self):
        return {}

    def setConfig(self, config):
        pass


class MyWidgetWrapperFactory(QgsEditorWidgetFactory):
    def __init__(self):
        QgsEditorWidgetFactory.__init__(self, 'My test widget')

    def create(self, layer, fieldIndex, editor, parent):
        return MyWidgetWrapper(layer, fieldIndex, editor, parent)

    def configWidget(self, layer, fieldIndex, parent ):
        return MyWidgetWrapperConfig(layer, fieldIndex, parent)
